<?php
require_once 'config.php';

if (!file_exists('post_data.json')) {
    die('No post data found.');
}

$data = json_decode(file_get_contents('post_data.json'), true);
$post_text = $data['post_text'];
$image = $data['image'];

// Login to get access_token
$login_url = API_URL . 'api/auth';
$login_data = [
    'username' => USERNAME,
    'password' => PASSWORD
];

$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, $login_url);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_POST, true);
curl_setopt($ch, CURLOPT_POSTFIELDS, $login_data);
$response = curl_exec($ch);
curl_close($ch);

$login_response = json_decode($response, true);

if (empty($login_response['access_token'])) {
    file_put_contents('error_log.txt', date('Y-m-d H:i:s') . " - Login failed: " . json_encode($login_response) . "\n", FILE_APPEND);
    die('Login failed');
}

$access_token = $login_response['access_token'];

// Prepare post data
$post_url = API_URL . 'api/posts';
$post_data = [
    'access_token' => $access_token,
    'text' => $post_text
];

$image_path = __DIR__ . '/uploads/' . $image;

if (file_exists($image_path)) {
    $post_data['postFile'] = new CURLFile($image_path);
}

$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, $post_url);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_POST, true);
curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data);
$response = curl_exec($ch);
curl_close($ch);

$post_response = json_decode($response, true);

if (!empty($post_response['post_id'])) {
    file_put_contents('success_log.txt', date('Y-m-d H:i:s') . " - Posted: ID " . $post_response['post_id'] . "\n", FILE_APPEND);
    echo "Post successful: ID " . $post_response['post_id'];
} else {
    file_put_contents('error_log.txt', date('Y-m-d H:i:s') . " - Post failed: " . json_encode($post_response) . "\n", FILE_APPEND);
    echo "Post failed";
}
?>
